<template>
  <div class="shelves-step">
    <div class="shelves-header">
      <a href="#" @click="skipStep">{{
        $t('modal.preference.shelvesStep.skip')
      }}</a>
      <h4 class="heading--lg heading--primary heading--uppercase">
        {{ $t('modal.preference.shelvesStep.title') }}
      </h4>
      <ul class="list-dots">
        <li class="active"></li>
        <li class="no-hover"></li>
      </ul>
    </div>
    <div class="step_inner">
      <p>{{ $t('modal.preference.shelvesStep.text') }}</p>
    </div>
    <Loader :display="loading" />

    <ul
      v-if="!loading && shelvesList.length > 0"
      class="shelves-list content-to-display"
    >
      <li
        v-for="shelf in shelvesList"
        :key="shelf.id"
        :shelf="shelf.id"
        @click="selectShelf(shelf.id)"
      >
        <img
          :src="shelfThumb(shelf)"
          alt=""
          width="230"
          height="118"
          :shelf="shelf.id"
        />
        <AppButton
          :ref="`selected-${shelf.id}`"
          :theme="btnTheme"
          :shelf="shelf.id"
        >
          {{ shelf.name }}
        </AppButton>
      </li>
    </ul>

    <div class="step_actions">
      <strong>{{ $t('modal.preference.shelvesStep.or') }}</strong>
      <AppButton
        :ref="`selected-0`"
        :theme="btnTheme"
        style="margin-left: 15px"
        @click="selectShelf('0')"
        >{{ $t('modal.preference.shelvesStep.allShelves') }}</AppButton
      >
    </div>
    <br />
    <div class="step__actions step__actions--alt text--center">
      <AppButton :ref="`next-step`" :theme="`disable`" @click="nextStep">{{
        $t('modal.preference.shelvesStep.btn')
      }}</AppButton>
    </div>
  </div>
</template>

<script>
import AppButton from '@/components/ui/AppButton'
import Loader from '~/components/ui/Loader'
export default {
  name: 'ShelvesStep',
  components: { AppButton, Loader },
  data() {
    return {
      loading: true,
      shelvesList: [],
      shelvesSelected: []
    }
  },
  computed: {
    btnTheme() {
      return 'select'
    }
  },
  async mounted() {
    const data = await this.$api.getShelvesList()
    if (data) {
      this.shelvesList = data
      this.loading = false

      this.$utils.gtmEvent({
        event: 'gtm.event',
        EventCategory: 'PopIn',
        EventAction: 'Preference-Rayons',
        EventLabel: 'Affichage_rayons'
      })
    }
  },
  methods: {
    nextStep() {
      if (this.shelvesSelected.length > 0) {
        this.$utils.gtmEvent({
          event: 'gtm.event',
          EventCategory: 'PopIn',
          EventAction: 'Preference-Rayons',
          EventLabel: `Clic_(${this.getSelectedKeys().join(', ')})`
        })

        this.$emit('update-shelves', this.shelvesSelected)
        this.$emit('get-step', 'genres-step')
      }
    },
    shelfThumb(shelf) {
      return `${this.$config.izneoUrl}/${this.$i18n.locale}/images/Shelf/${shelf.id}-230x118.jpg?v=${shelf.version}`
    },
    selectShelf(shelfId) {
      if (shelfId !== '') {
        if (shelfId === '0') {
          if (!this.shelvesSelected.includes(shelfId)) {
            if (this.shelvesSelected.length > 0) {
              this.shelvesSelected.forEach((v) => {
                this.$refs[`selected-${v}`][0].$el.classList.replace(
                  'active',
                  'select'
                )
              })
            }
            this.shelvesSelected = []
            this.shelvesSelected.push(shelfId)
            this.$refs[`selected-${shelfId}`].$el.classList.replace(
              'select',
              'active'
            )
          }
        } else {
          if (
            this.shelvesSelected.length > 0 &&
            this.shelvesSelected[0] === '0'
          ) {
            this.shelvesSelected = []
            this.$refs['selected-0'].$el.classList.replace('active', 'select')
          }
          if (this.shelvesSelected.includes(shelfId)) {
            this.shelvesSelected.splice(
              this.shelvesSelected.indexOf(shelfId),
              1
            )
            this.$refs[`selected-${shelfId}`][0].$el.classList.replace(
              'active',
              'select'
            )
          } else {
            this.shelvesSelected.push(shelfId)
            this.$refs[`selected-${shelfId}`][0].$el.classList.replace(
              'select',
              'active'
            )
          }
        }
        this.checkShelves()
      }
    },
    skipStep() {
      const data = {
        shelves: 'skip',
        genres: 'skip'
      }
      const result = this.$api.saveUserPreference(data)
      if (result) {
        this.$emit('display-modal')
        this.$emit('close')
      }
    },
    checkShelves() {
      if (this.shelvesSelected.length > 0) {
        this.$refs[`next-step`].$el.classList.remove('disable')
      } else {
        this.$refs[`next-step`].$el.classList.add('disable')
      }
    },
    getSelectedKeys() {
      const selectedIds = this.shelvesSelected
      return this.shelvesList
        .filter((v) => selectedIds.indexOf(v.id) >= 0)
        .map((v) => v.key)
    }
  }
}
</script>

<style lang="scss">
.shelves-step {
  text-align: left;

  .shelves-header {
    a {
      float: right;
      font-size: 20px;
    }
  }

  .step {
    &_inner {
      font-size: 25px;
    }

    &_actions {
      strong {
        font-size: 25px;
      }
    }
  }

  .shelves-list {
    li {
      display: inline-block;
      max-width: 33.3%;
      padding: 0 15px;
      box-sizing: border-box;
      position: relative;
      font-size: 13px;
      font-weight: 700;
      color: #3e3e3e;
      text-align: center;
      margin: 20px 0;
      @include screen-size(md) {
        max-width: unset;
      }

      .select,
      .active {
        width: 100%;
        padding: 12px 10px 13px;
      }

      img {
        display: block;
        width: 100%;
        height: auto;
        margin: 0;
        cursor: pointer;
        &:hover + .select {
          background-color: #eb4900;
          color: #fff;
        }
      }
    }
  }
}
</style>
